/*
 * @Author: ZhengXiaowei
 * @Date: 2019-10-15 12:06:28
 * @LastEditors: ZhengXiaowei
 * @LastEditTime: 2019-10-15 14:32:19
 * @Description: api 配置入口
 */
import fetch from "@system.fetch";
import Fly from "flyio/dist/npm/hap";
import apiConfig from "./config";
import prompt from '@system.prompt';
import { getToken, clearToken } from "./utils";

var fly = new Fly(fetch);
var qs = require('qs');
fly.config.baseURL = apiConfig.baseURL;
fly.config.headers["Content-Type"] =
  "application/x-www-form-urlencoded;charset=utf-8";

const filterNoToken = ["/login"];

fly.interceptors.request.use(async config => {
  // 过滤一些不需要登录的路由d
  if (filterNoToken.indexOf(config.url) === -1) {
    let token = await getToken();
    if (config.headers) config.headers.Authorization = token;
    else config.headers = { Authorization: token };
    if (config.method === "POST") {
      config.body=qs.stringify(config.body);
    } 
    console.log('请求开始！',config);
    return config;
  } else return config;
});

fly.interceptors.response.use(
  res => {
    console.log('响应开始',res);
    if (!res.data.code) {
      return res.data.data;
    } else if (res.data.code === 10023) {
      // token失效
      clearToken();
      return getToken().then(token => {
        return r(res.config);
      });
    } 
    else {
      prompt.showToast({
        message: res.data.msg
      })
      return Promise.reject(res);
    }
  },
  err => {
    console.log('err',err)
    return Promise.reject(err);
  }
);

export default fly;
